/*
 *  Copyright (c) 2000-2003 Barak Weichselbaum <barak@komodia.com>
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Contact info:
 * -------------
 *
 * Site:					http://www.komodia.com
 * Main contact:			barak@komodia.com
 * For custom projects, 
 * consulting, or other
 * paid services:			sales@komodia.com
 */

#if !defined(AFX_DNSTCPSOCKET_H__71FB8EC5_6D38_4EC8_9D83_308DACFC9FEA__INCLUDED_)
#define AFX_DNSTCPSOCKET_H__71FB8EC5_6D38_4EC8_9D83_308DACFC9FEA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ErrorHandler.h"

#include "TCPSocketAsync.h"

namespace KomodiaDNS
{

class CDNSSocket;

class CDNSTCPSocket : public CTCPSocketAsync
{
public:
	//Ctor and Dtor
	CDNSTCPSocket(CDNSSocket* pSocket);
	virtual ~CDNSTCPSocket();
protected:
	//Events
	virtual BOOL OnSocketClose(int iErrorCode);
	virtual BOOL OnSocketReceive(int iErrorCode);
	virtual BOOL OnSocketConnect(int iErrorCode);

	//Don't need these events
	NO_OnSocketTimeout
	NO_OnSocketWrite
	NO_OnSocketAccept
	NO_OnSocketOOB
private:
	//No copy ctor
	CDNSTCPSocket(const CDNSTCPSocket& rSocket);

	//No copy operator
	CDNSTCPSocket& operator=(const CDNSTCPSocket& rSocket);

	//our father
	CDNSSocket* m_pDNSSocket;

	//Buffer for TCP fragmentation
	char* m_pBuffer;

	//Position whithin the buffer
	int m_iBufferPosition;
};

//of namespace
}

#endif // !defined(AFX_DNSTCPSOCKET_H__71FB8EC5_6D38_4EC8_9D83_308DACFC9FEA__INCLUDED_)
