/*
 *  Copyright (c) 2000-2003 Barak Weichselbaum <barak@komodia.com>
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Contact info:
 * -------------
 *
 * Site:					http://www.komodia.com
 * Main contact:			barak@komodia.com
 * For custom projects, 
 * consulting, or other
 * paid services:			sales@komodia.com
 */

#if !defined(AFX_TCPPORTSCANNERLINEAR_H__A4B9D6B6_7BA5_45E5_AC44_9EACFA2C18A2__INCLUDED_)
#define AFX_TCPPORTSCANNERLINEAR_H__A4B9D6B6_7BA5_45E5_AC44_9EACFA2C18A2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TCPPortScanner.h"

KOMODIA_NAMESPACE_START

class CTCPPortScannerLinear : public CTCPPortScanner  
{
public:
	//Do the scan
	virtual BOOL Scan(const std::string& rDestinationAddress);
	virtual BOOL Scan(IP aTarget);

	//Ctor and Dtor
	CTCPPortScannerLinear();
	virtual ~CTCPPortScannerLinear();
private:
	//No copy Ctor
	CTCPPortScannerLinear(const CTCPPortScannerLinear& rScanner);

	//No copy operator
	CTCPPortScannerLinear& operator=(const CTCPPortScannerLinear& rScanner);
};

KOMODIA_NAMESPACE_END

#endif // !defined(AFX_TCPPORTSCANNERLINEAR_H__A4B9D6B6_7BA5_45E5_AC44_9EACFA2C18A2__INCLUDED_)
