/*
 *  Copyright (c) 2000-2003 Barak Weichselbaum <barak@komodia.com>
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Contact info:
 * -------------
 *
 * Site:					http://www.komodia.com
 * Main contact:			barak@komodia.com
 * For custom projects, 
 * consulting, or other
 * paid services:			sales@komodia.com
 */

#if !defined(AFX_TCPPORTSCANNERMULTITHREADED_H__DC4B6B1C_8905_41A0_8667_255FE94F65F5__INCLUDED_)
#define AFX_TCPPORTSCANNERMULTITHREADED_H__DC4B6B1C_8905_41A0_8667_255FE94F65F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TCPPortScanner.h"

KOMODIA_NAMESPACE_START

class CThreadPool;

class CTCPPortScannerMultithreaded : public CTCPPortScanner
{
public:
	//Get/set max threads (default is 10)
	void SetMaxThreads(int iThreads);
	int GetMaxThreads()const;

	//Set our multithreaded pool
	void SetMultithreadedPool(CThreadPool* pPool);

	//Do the scan
	virtual BOOL Scan(const std::string& rDestinationAddress);
	virtual BOOL Scan(IP aTarget);

	//Ctor and Dtor
	CTCPPortScannerMultithreaded();
	virtual ~CTCPPortScannerMultithreaded();
private:
	//No copy Ctor
	CTCPPortScannerMultithreaded(const CTCPPortScannerMultithreaded& rScanner);

	//No copy operator
	CTCPPortScannerMultithreaded& operator=(const CTCPPortScannerMultithreaded& rScanner);

	//Our socket proc
	static void SocketProc(LPVOID lpData);

	//Our thread pool
	CThreadPool* m_pThreadPool;

	//Are we the owners of the thread pool ?
	BOOL m_bOwners;

	//Max threads
	int m_iMaxThreads;
};

KOMODIA_NAMESPACE_END

#endif // !defined(AFX_TCPPORTSCANNERMULTITHREADED_H__DC4B6B1C_8905_41A0_8667_255FE94F65F5__INCLUDED_)
